/*
 * Created by SharpDevelop.
 * User: phil
 * Date: 2010.03.30.
 * Time: 15:57
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using System.ComponentModel;

namespace TetheredSun.Controls
{
	/// <summary>
	/// Description of Axis.
	/// </summary>
	public class Axis : Component
	{
		protected double minimum;
		protected double maximum;
		protected AxisType type;
		protected Title title = new Title();
		protected bool gridVisible = true;
		protected bool autoscaled = true;
		
		public Axis(double minimum, double maximum, AxisType type)
		{
			this.minimum = minimum;
			this.maximum = maximum;
			this.type = type;
		}
		
		public Axis(AxisType type) : this(0.0, 0.0, type) { }
		
		
		public bool Autoscaled {
			get { return autoscaled; }
			set { autoscaled = value; }
		}
		
		public bool GridVisible {
			get { return gridVisible; }
			set { gridVisible = value; }
		}
		
		public double Minimum {
			get { return minimum; }
			set { minimum = value; }
		}
		
		public double Maximum {
			get { return maximum; }
			set { maximum = value; }
		}
		
		[DesignerSerializationVisibility(DesignerSerializationVisibility.Content)]
		public Title Title {
			get { return title; }
		}
		
		internal void Scroll(int steps, int gridCount)
		{
			double move = -steps * (maximum - minimum) / gridCount;
			maximum += move;
			minimum += move;
		}
		
		internal void Zoom(int steps)
		{
			
			double zoom = Math.Pow(2, steps);
			double middle = (maximum + minimum) / 2;
			maximum = (maximum - middle) * zoom + middle;
			minimum = (minimum - middle) * zoom + middle;
		}
	}
}
